commit ff4edf2fa2b3b326b0930093675d0269b90081bb
Author: freddy77 <freddy77>
Date:   Sun Jan 13 20:01:43 2008 +0000

    detect cancellation error on ODBC

diff --git a/ChangeLog b/ChangeLog
index bd33ef6..021efb9 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Sun Jan 13 20:59:55 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc.c src/odbc/unittests/cancel.c src/tds/token.c:
+	- detect cancellation and add proper error
+	- remove errors from cancel test
+
 Sat Jan 12  1:13:30 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/blob1.c: small fix for 64bit
 	* src/tds/net.c: fix for heavy loads
@@ -50,4 +55,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2467 2008/01/12 00:14:11 freddy77 Exp $
+$Id: ChangeLog,v 1.2468 2008/01/13 20:01:43 freddy77 Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index a638dc7..df2cc9a 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.466 2008/01/10 13:11:07 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.467 2008/01/13 20:01:44 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -3260,6 +3260,7 @@ odbc_process_tokens(TDS_STMT * stmt, unsigned flag)
 		case TDS_NO_MORE_RESULTS:
 			return TDS_CMD_DONE;
 		case TDS_CANCELLED:
+			odbc_errs_add(&stmt->errs, "HY008", NULL);
 		case TDS_FAIL:
 			return TDS_CMD_FAIL;
 		}
@@ -4187,6 +4188,8 @@ SQLPrepare(SQLHSTMT hstmt, SQLCHAR FAR * szSqlStr, SQLINTEGER cbSqlStr)
 				continue;
 			case TDS_NO_MORE_RESULTS:
 				break;
+			case TDS_CANCELLED:
+				odbc_errs_add(&stmt->errs, "HY008", NULL);
 			default:
 				stmt->errs.lastrc = SQL_ERROR;
 				break;
@@ -5683,6 +5686,9 @@ SQLGetTypeInfo(SQLHSTMT hstmt, SQLSMALLINT fSqlType)
 			if (n >= varchar_pos && varchar_pos > 0)
 				goto redo;
 			break;
+		case TDS_CANCELLED:
+			odbc_errs_add(&stmt->errs, "HY008", NULL);
+			break;
 		}
 		if (!tds->current_results)
 			break;
diff --git a/src/odbc/unittests/cancel.c b/src/odbc/unittests/cancel.c
index 6aa5e3f..a43db5b 100644
--- a/src/odbc/unittests/cancel.c
+++ b/src/odbc/unittests/cancel.c
@@ -1,8 +1,15 @@
 /* Testing SQLCancel() */
 
 #include "common.h"
+
+/* TODO port to windows, use thread */
+
 #include <signal.h>
 
+#if HAVE_UNISTD_H
+#include <unistd.h>
+#endif /* HAVE_UNISTD_H */
+
 #ifdef HAVE_ALARM
 
 #define CHECK_RCODE(t,h,m) \
@@ -15,7 +22,7 @@
       exit(1); \
    }
 
-static SQLCHAR sqlstate[SQL_SQLSTATE_SIZE + 1];
+static char sqlstate[SQL_SQLSTATE_SIZE + 1];
 
 static void
 getErrorInfo(SQLSMALLINT sqlhdltype, SQLHANDLE sqlhandle)
@@ -32,8 +39,9 @@ getErrorInfo(SQLSMALLINT sqlhdltype, SQLHANDLE sqlhandle)
 			      (SQLCHAR *) sqlstate,
 			      (SQLINTEGER *) & naterror,
 			      (SQLCHAR *) msgtext, (SQLSMALLINT) sizeof(msgtext), (SQLSMALLINT *) & msgtextl);
+	sqlstate[sizeof(sqlstate)-1] = 0;
 	fprintf(stderr, "Diagnostic info:\n");
-	fprintf(stderr, "  SQL State: %s\n", (char *) sqlstate);
+	fprintf(stderr, "  SQL State: %s\n", sqlstate);
 	fprintf(stderr, "  SQL code : %d\n", (int) naterror);
 	fprintf(stderr, "  Message  : %s\n", (char *) msgtext);
 }
@@ -66,10 +74,11 @@ main(int argc, char **argv)
 	use_odbc_version3 = 1;
 	Connect();
 
-	printf(">> Select tab1...\n");
+	printf(">> Wait 5 minutes...\n");
 	alarm(4);
 	signal(SIGALRM, sigalrm_handler);
 	rcode = SQLExecDirect(Statement, (SQLCHAR *) "WAITFOR DELAY '000:05:00'", SQL_NTS);
+	alarm(0);
 	if (rcode != SQL_ERROR) {
 		fprintf(stderr, "SQLExecDirect should return error\n");
 		return 1;
@@ -81,7 +90,10 @@ main(int argc, char **argv)
 		return 1;
 	}
 	printf(">> ...  done rcode = %d\n", rcode);
-	signal(SIGINT, NULL);
+
+	ResetStatement();
+
+	Command(Statement, "SELECT name FROM sysobjects WHERE 0=1");
 
 	Disconnect();
 	return 0;
diff --git a/src/tds/token.c b/src/tds/token.c
index 0c80a00..e6d5a6d 100644
--- a/src/tds/token.c
+++ b/src/tds/token.c
@@ -42,7 +42,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: token.c,v 1.343 2007/12/28 23:00:18 jklowden Exp $");
+TDS_RCSID(var, "$Id: token.c,v 1.344 2008/01/13 20:01:45 freddy77 Exp $");
 
 static int tds_process_msg(TDSSOCKET * tds, int marker);
 static int tds_process_compute_result(TDSSOCKET * tds);
@@ -2238,7 +2238,7 @@ tds_process_end(TDSSOCKET * tds, int marker, int *flags_parm)
 	if (IS_TDSDEAD(tds))
 		return TDS_FAIL;
 
-	return TDS_SUCCEED;
+	return was_cancelled ? TDS_CANCELLED : TDS_SUCCEED;
 }
 
 /**

